#!/usr/bin/env python
#
#       input.py
#       
#       Copyright 2009 Gordon Allott <gordallott@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
from SDL import *

class Input(object):
    
    button_down = 0
    mouse_down = False
    mouse_x = 0.0
    mouse_y = 0.0
    
    do_quit = False
    
    inited = False
    
    do_left = False
    do_right = False
    do_up = False
    do_down = False
    screen_size = None
    
    def __init__(self, screen_size=(1024, 768)):
        #if not self.__class__.inited:
            #SDL_Init(SDL_INIT_INPUT)
        if self.__class__.screen_size == None:
            self.__class__.screen_size = screen_size
        pass
        
    def pump(self):
        while SDL_PollEvent():
            event = SDL_PollEventAndReturn()
            if event.type == SDL_KEYDOWN:
                self.__class__.button_down += 1
                
                if event.keysym.sym == SDLK_ESCAPE:
                    self.__class__.do_quit = True
                    
                elif event.keysym.sym == SDLK_LEFT:
                    self.__class__.do_left = True
                elif event.keysym.sym == SDLK_RIGHT:
                    self.__class__.do_right = True
                elif event.keysym.sym == SDLK_UP:
                    self.__class__.do_up = True
                elif event.keysym.sym == SDLK_DOWN:
                    self.__class__.do_down = True
                    
            if event.type == SDL_KEYUP:
                self.__class__.button_down -= 1
                
                if event.keysym.sym == SDLK_LEFT:
                    self.__class__.do_left = False
                elif event.keysym.sym == SDLK_RIGHT:
                    self.__class__.do_right = False
                elif event.keysym.sym == SDLK_UP:
                    self.__class__.do_up = False
                elif event.keysym.sym == SDLK_DOWN:
                    self.__class__.do_down = False
                
            if event.type == SDL_MOUSEMOTION:
                self.__class__.mouse_x = event.x / float(self.__class__.screen_size[0])
                self.__class__.mouse_y = event.y / float(self.__class__.screen_size[1])
                
            if event.type == SDL_MOUSEBUTTONDOWN:
                self.__class__.mouse_down = True
            if event.type == SDL_MOUSEBUTTONUP:
                self.__class__.mouse_down = False
                
            if event.type == SDL_QUIT:
                self.__class__.do_quit = True
